#ident "@(#) space.c 2.0 MAY 19,2003 d3.0 alpha03/chim V542" 
/*
 *   Portions Copyright 1994 The Santa Cruz Operation, Inc
 *                    All Rights Reserved
 *   This Module contains Proprietary Information of
 *   The Santa Cruz Operation and should be treated as Confidential.
 */

/**********************************************************************
*
* Copyright 1994 Adaptec, Inc.,  All Rights Reserved.
*
* This software contains the valuable trade secrets of Adaptec.  The
* software is protected under copyright laws as an unpublished work of
* Adaptec.  Notice is for informational purposes only and does not 
* imply publication.  The user of this software may make copies of 
* the software for use with parts manufactured by Adaptec or under 
* license from Adaptec and for no other use.
*
 *********************************************************************/
#include "sys/types.h"
#include "sys/iobuf.h"
#include "sys/buf.h"
#include "sys/immu.h"
#include "sys/dio.h"
#include "sys/disk.h"
#include "sys/fs/s5param.h"
#include "sys/scsi.h"
#include "sys/elog.h"
#include "sys/open.h"
#include "sys/devreg.h"
#include "sys/adaptec.h"

#ifdef BTLD_CREATE
#include "../drv/ad320.h"
#else
#include <sys/ad320.h>
#endif

#include "config.h"		   /* Get tunables */


#define MAX_DEV	 16
#define MAX_LUN   8
#ifndef SCSI_NAD320
#define SCSI_NAD320 2
#define AD320_INSTALL	1
#else
#define AD320_INSTALL	0
#endif
int Ad320_Install=AD320_INSTALL;

#if SCSI_NAD320 == 0
#undef SCSI_NAD320
#define SCSI_NAD320 1
#endif
int ad320_num_adapters = SCSI_NAD320;

#ifdef SCSI_NSTP
int ad320_num_tapes = SCSI_NSTP;
#else
int ad320_num_tapes = 0;
#endif

#ifdef SCSI_NSROM
int ad320_num_cdroms = SCSI_NSROM;
#else
int ad320_num_cdroms = 0;
#endif						/* @0002 end */

#ifdef SCSI_NSDSK				/* @0002  begin */
extern int	Sdsk_num_disks;
extern int	Sdsk_num_rb;
int ad320_numiobs = SCSI_NSDSK * (SDSKOUT + 1);
#else
int ad320_numiobs = 0;
int Sdsk_no_tag = 1;		/* THIS IS NOT TUNABLE. DO NOT MODIFY */
int Sdsk_no_sg = 1;		/* THIS IS NOT TUNABLE. DO NOT MODIFY */
#endif

unsigned char ad320_installed[SCSI_NAD320];	/* marked if installed */

struct dkcntlrtab ad320ctlrinfo[SCSI_NAD320];/* info. for disk setup */
SHAREG_EX ad320_reg[SCSI_NAD320];		/* un-registered adapter */
/* info. for Sharegister */
/* void  *ad320_info[SCSI_NAD320];		 store lance HBAs in order */

/***************************************************************************
 *                        USER CONFIGURABLE PARAMETERS 
 *
 *	If you build the kernel as is, all the configuration parameters
 *	are set to the default by ScsiSelect (through running PCI
 *	configuration utility).  If you want to change the default, 
 *	follow the instructions below to change as appropriate.
 *
 *	How to set configuration paramters:
 *
 * 	For "aha_change" type:
 *	The first number indicates whether the default should be changed.  
 *	If set to 0, the parameter will be set to the default.  If set 
 *	to 1, the second number will be used to override the default.
 *	
 *	For "int" and "unsigned int" types:
 *	Set the new value according to the specified valid values. 
 *
 *                    Do not modify above this line                        
 ***************************************************************************/

/* Interrupt Distribution.  Currently set to 1 for base cpu interrupts only.
 * Set to DRIVER_CPU_DEFAULT to cause interrupt distribution across all cpus.
 */
int ad320_processor = 1;

/*	Host Adapter SCSI ID
 *      Set the SCSI ID for the Host Adapter.  
 */
aha_change ad320_hba_id[SCSI_NAD320];

/*	Parity Option
 *	This specifies whether the host adapter will check parity 
 *	on incoming SCSI data. (parity will always generate on 
 *	outbound SCSI data)  
 *	The supported values are:
 *		1		parity checking is enabled.
 *		0		parity checking is disbled.
 */
aha_change ad320_parity[SCSI_NAD320];

/*	Time Selection
 *	This specifies the length of time in milliseconds the host
 *	adapter will wait for a target to respond to selection before
 *	aborting the selection precedure.  The supported values are :
 *		AD320_SEL_256	=	256 milliseconds
 *		AD320_SEL_128 	=	128 milliseconds
 *		AD320_SEL_64	=	64 milliseconds
 *		AD320_SEL_32	=	32 milliseconds
 *	
 *	For example: set the selection timeout on the first host adapter
 *	to 128 milliseconds:
 *	
 *	aha_change ad320_sel_timeout[SCSI_NAD320]={1,AD320_SEL_128};
 */
aha_change ad320_sel_timeout[SCSI_NAD320];

/*	Allow Disconnection
 *	This is a 16-bit field where each bit corresponds to a target ID
 *	(bit 0 for target ID 0, and so forth).  If bit is set to 1, 
 *	disconnection is allowed for the corresponding target ID.
 *	Default value is allow disconnection. If you want be able to 
 *	change this value in ScsiSelect without having to rebuild kernel
 * 	modify to:   aha_change ad320_disconnect[SCSI_NAD320];
 *	default is : aha_change ad320_disconnect[SCSI_NAD320]={1,0xFFFF};
 *
 *      **NOTE** If Disconnection is not allowed, tag-queueing must be
 *      turned off.  Turning on Tag-queuing must also allow
 *	Disconnection!.
 */
aha_change ad320_disconnect[SCSI_NAD320] = {1, 0xFFFF};

/*	Ignore (suppress) underrun
 *	If set to 1, ignore underrun as an error.  If set to 0, report
 *	underrun as an error.  Default is 1, ignore underrun as an error.
 */
aha_change ad320_underrun[SCSI_NAD320][16];

/* 	If set to 1, driver will do tagged queuing. Set to 0 to disable.
 * 	Default is 1 to enable.
 */
int ad320_do_tagged = 1;

/* 	If set to 1, driver will do scatter-gather. Set to 0 to disable.
 * 	Default is 1 to enable.
 */
int ad320_do_sgatter = 1;

/* 	Suppress scanning for LUN
 *	During initialization, the driver will scan all devices 
 *	to obtain negotiation information.  By default, all target
 *	IDs are scanned, but not the LUN. 
 *	0 = disable lun scanning (default).  1 = enable lun scanning.
 */
int ad320_scan_lun = 0;

/*	Enable instrumentation for each HA (default is disabled).
 *
 *	NOTE: Normally CIO software will enable instrumentation. 
 *	Therefore, it is not necessary to enable instrumentation here.
 *	However, enabling will provide more accurate instrumentation 
 *	information but at a slight expense of performance.
 *
 *	EXAMPLE: Enable the first and third channel or HA: 
 *	aha_change ad320_instr_enable[SCSI_NAD320]={1,1, 0,0, 1,1}; 
 */
aha_change ad320_instr_enable[SCSI_NAD320];

/* 	ad320_instr_errlogsz  - If Instrumentation is used, the
 *	maximum number of entries in the error log. Each entry
 * 	is approximately 40 bytes long.
 *	min = 1, default = 32, max = limited by available memory. 
 */
unsigned short ad320_instr_errlogsz = 32;

/* 	ad320_instr_buffersz  - If Instrumentation is used, the
 *	maximum number of 4kbyte pages to allocate for data 
 *	for SCSI pass thru commands (read/write/etc.). 
 *	min = 2, default = 2, max = 16. 
 */
unsigned short ad320_instr_buffersz = 2;

/*	ad320_message_level  - tunes the amount of messages to be
 *	dislayed. 
 *	0 - all messages will be printed 
 *	1 - only notices, warnings, and errors will be printed 
 *	2 - only warnings and errors will be printed 
 * 	3 - only error messages will be printed 
 *	9 - no message wil be printed
 */
unsigned short ad320_message_level = 0;

/*	ad320_autosense_enable  - set whether driver should automatically
 *	try to get the sense information in a check condition.
 *	1 - (default) if a check condition occurs, driver will do a 
 *	request sense to obtain the sense information. This information
 *	will be available in the req_p->scsi_sense field.
 *	0 - A check condition will be reported to the calling layer and
 *	it will be responsible for performing the request sense.
 */
unsigned short ad320_autosense_enable = 1;

/*	Maximum Tagged Queue - If tagged queuing is used,
 *	The maximum number of tagged queuing IOBs the driver will
 * 	send to each SCSI device.  The valid values are 1 to 32.  
 *	The default value is 8. 
 */
aha_change ad320_MaxTagIOBs[SCSI_NAD320];

/* 	ad320_hw_map - IO mapped or Memory mapped.
 * 	0 - IO mapped. 1 = memory mapped.
 *	default is 0, IO mapped.
 */
int ad320_hw_map = 0;

#ifdef CLED_0
extern void cled_entry();
void (*ad320_cled_entry)() = cled_entry; /* address of cled driver entry */
extern char cled_opcode[256];
char *ad320_cled_opcode = cled_opcode; /* address of cled opcode table */
extern int cled_sdsk_stop_option;
int * ad320_cled_sdsk_stop_option = &cled_sdsk_stop_option;
#else /* #ifdef CLED_0 */
void (*ad320_cled_entry)() = 0;		/* cled driver is not preent */
char *ad320_cled_opcode = 0;		/* cled opcode not present */
int *ad320_cled_sdsk_stop_option = 0;
#endif /* #ifdef CLED_0 */

caddr_t ad320phystokv(phys)
register paddr_t phys;
{
	return ((caddr_t)phystokv(phys));
}
